#!/usr/bin/perl -W

# parse_cvs.pl, ABr, 2002-Jan-01
#
# This utility program is invoked by the reset_perms.sh
# CVS helper script. It turns out it was just too complex
# to try and use sed to build the list of file names passed
# to loginfo.

use strict ;
use Carp ;

my $f = $ARGV[0] ;
my $action = $ARGV[1] ;

open( F, "<$f" ) or die( "Error opening $f: $!\n" ) ;
my $line = <F> ;
while( chomp( $line ) ) {}
#print "line(1)='$line'\n" ;

$line =~ s/.*?((Added|Modified|Removed) Files:[^A-Za-z0-9_.]+.*)Log Message:.*/$1/ ;
#print "line(2)='$line'\n" ;

# added files
my $added_files = $line ;
if( $added_files =~ m/Added Files:[^A-Za-z0-9_.]+/ ) {
  $added_files =~ s/.*Added Files:[^A-Za-z0-9_.]+(.*)/$1/ ;
  if( $added_files =~ m/(Modified|Removed) Files:/ ) {
    $added_files =~ s/(.*?)(Modified|Removed) Files:.*/$1/ ;
  } #if
} else {
  $added_files = "" ;
} #if
#print "added_files='$added_files'\n" ;

# modified files
my $modified_files = $line ;
if( $modified_files =~ m/Modified Files:[^A-Za-z0-9_.]+/ ) {
  $modified_files =~ s/.*Modified Files:[^A-Za-z0-9_.]+(.*)/$1/ ;
  if( $modified_files =~ m/(Added|Removed) Files:/ ) {
    $modified_files =~ s/(.*?)(Added|Removed) Files:.*/$1/ ;
  } #if
} else {
  $modified_files = "" ;
} #if
#print "modified_files='$modified_files'\n" ;

# removed files
my $removed_files = $line ;
if( $removed_files =~ m/Removed Files:[^A-Za-z0-9_.]+/ ) {
  $removed_files =~ s/.*Removed Files:[^A-Za-z0-9_.]+(.*)/$1/ ;
  if( $removed_files =~ m/(Added|Modified) Files:/ ) {
    $removed_files =~ s/(.*?)(Added|Modified) Files:.*/$1/ ;
  } #if
} else {
  $removed_files = "" ;
} #if
#print "removed_files='$removed_files'\n" ;

if( $action =~ m/^added$/i ) {
  print $added_files ;
} elsif( $action =~ m/^modified$/i ) {
  print $modified_files ;
} else {
  print $removed_files ;
} #if

